#include <tchar.h>
#include <windows.h>
#include <iostream>
#include <string>

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{

	HANDLE m_hCommPort = CreateFile(_T("COM1"), GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, NULL, NULL);
	if (m_hCommPort == INVALID_HANDLE_VALUE) {
		cerr << "Error: " << GetLastError() << endl;
		return 1;
	}

	DCB dcb;
	memset(&dcb, 0, sizeof(dcb));
	dcb.DCBlength = sizeof(dcb);
	if (!BuildCommDCB(_T("baud=9600 parity=N data=8 stop=1"), &dcb))
	{
		cerr << "Error: " << GetLastError() << endl;
		return 1;
	}
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fAbortOnError = FALSE;
	if (!SetCommState(m_hCommPort,&dcb))
	{
		cerr << "Error: " << GetLastError() << endl;
		return 1;
	}

	while(1) {
		string i;
		cin >> i;
		char buf[1];
		if (i.compare("on")==0) buf[0] = 'a'; 
		if (i.compare("off")==0) buf[0] = 'b';
		if (i.compare("q")==0) {
			CloseHandle(m_hCommPort);
			return 0;
		}

		DWORD written;
		WriteFile(m_hCommPort, buf, 1, &written, NULL);
		
		DWORD read;
		ReadFile(m_hCommPort, buf, 1, &read, NULL);
		if (buf[0]=='P') cout << "Button pressed." << endl;
			else cout << "Button released." << endl;
	}

	return 0;
}

